--[[

Copyright (C) 2014 Vatten (vaften@gmail.com)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
]]

--todo startup on inf weps like switch hog etc, fix economy leakage

--load locale and utils.
HedgewarsScriptLoad("/Scripts/Locale.lua")
HedgewarsScriptLoad("/Scripts/Utils.lua")

--for the crate, so it will give cash
local CRATE_TEST=0

--for double tap
local DOUBLE_TAP=0
local DOUBLE_TAP_BUTTON=0

--team name on current hog
--also for speed improvements
local TURN_TEAM=0

local START_TEST=0

--1=1 wep, 2=2wep, 3=inf wep, 4=see cost, 5=go back
local BUY_MODE={}
local RETURN_MODE={}

local TEAM_CASH={}
local TEAM_WEAPONS={}

local TEAMS={}
local STARTING_CASH=0

--CONSTANTS
local PLAY_MODE=-1

--weapontype,ammo,probability_in_crates,duration,*times_your_choice,(name - "am"),1_cost, inf_cost
local ALL_WEAPONS = {
	{amBazooka, 0, 1, 0, 1,"Bazooka",2,10},
	{amGrenade, 0, 1, 0, 1,"Grenade",2,10},
	{amKamikaze, 0, 1, 0, 1,"Kamikaze",1,5},
	{amSineGun, 0, 1, 0, 1,"SineGun",6,50},
	{amClusterBomb, 0, 1, 0, 1,"ClusterBomb",3,20},
	{amBee, 0, 1, 0, 1,"Bee",4,30},
	{amShotgun, 0, 0, 0, 1,"Shotgun",2,10},
	{amMine, 0, 1, 0, 1,"Mine",1,5},
	{amSniperRifle, 0, 1, 0, 1,"SniperRifle",1,5},
	{amDEagle, 0, 1, 0, 1,"DEagle",2,10},
	{amDynamite, 0, 1, 4, 1,"Dynamite",9,80},
	{amFirePunch, 0, 1, 0, 1,"FirePunch",3,20},
	{amHellishBomb, 0, 1, 5, 1,"HellishBomb",25,250},
	{amWhip, 0, 1, 0, 1,"Whip",1,5},
	{amPickHammer, 0, 1, 0, 1,"PickHammer",2,10},
	{amBaseballBat, 0, 1, 1, 1,"BaseballBat",7,60},
	{amMortar, 0, 1, 0, 1,"Mortar",1,5},
	{amCake, 0, 1, 4, 1,"Cake",25,250},
	{amSeduction, 0, 0, 0, 1,"Seduction",1,5},
	{amWatermelon, 0, 1, 5, 1,"Watermelon",25,250},
	{amDrill, 0, 1, 0, 1,"Drill",3,20},
	{amBallgun, 0, 1, 5, 1,"Ballgun",40,400},
	{amMolotov, 0, 1, 0, 1,"Molotov",3,20},
	{amBirdy, 0, 1, 0, 1,"Birdy",7,60},
	{amBlowTorch, 0, 1, 0, 1,"BlowTorch",4,30},
	{amRCPlane, 0, 1, 5, 1,"RCPlane",25,250},
	{amGasBomb, 0, 0, 0, 1,"GasBomb",3,20},
	{amFlamethrower, 0, 1, 0, 1,"Flamethrower",4,30},
	{amSMine, 0, 1, 0, 1,"SMine",5,40},
	{amHammer, 0, 1, 0, 1,"Hammer",1,5},
	{amSnowball, 0, 1, 1, 1,"Snowball",3,200},
	{amParachute, 0, 1, 0, 1,"Parachute",2,10},
	{amGirder, 0, 1, 0, 1,"Girder",4,400},
	{amSwitch, 0, 1, 0, 1,"Switch",4,50},
	{amLowGravity, 0, 1, 0, 1,"LowGravity",4,30},
	{amExtraDamage, 0, 1, 2, 1,"ExtraDamage",6,80},
	{amRope, 0, 1, 0, 1,"Rope",7,70},
	{amInvulnerable, 0, 1, 0, 1,"Invulnerable",5,50},
	{amExtraTime, 0, 1, 0, 1,"ExtraTime",4,400},
	{amLaserSight, 0, 1, 0, 1,"LaserSight",2,20},
	{amVampiric, 0, 1, 0, 1,"Vampiric",6,80},
	{amJetpack, 0, 1, 0, 1,"Jetpack",8,80},
	{amPortalGun, 0, 1, 2, 1,"PortalGun",15,400},
	{amResurrector, 0, 1, 3, 1,"Resurrector",8,80},
	{amTeleport, 0, 1, 0, 1,"Teleport",6,40},
	{amLandGun, 0, 1, 0, 1,"LandGun",5,400},
	{amTardis, 0, 1, 0, 1,"Tardis",2,10},
	{amIceGun, 0, 1, 0, 1,"IceGun",15,150},
	{amKnife, 0, 1, 0, 1,"Knife",2,20},
	{amRubber, 0, 1, 0, 1,"Rubber",5,400},
	{amAirAttack, 0, 1, 4, 1,"AirAttack",10,100},
	{amMineStrike, 0, 1, 5, 1,"MineStrike",15,150},
	{amPiano, 0, 1, 5, 1,"Piano",40,100},
	{amDrillStrike, 0, 1, 4, 1,"DrillStrike",15,150},
	{amNapalm, 0, 1, 5, 1,"Napalm",15,150}
}

------------------
--[[
See some yellow cash around the gear

@param gearUid 
	show some sparkles above that gear
]]
function CashAnimation(gearUid)
	local i=0
	while(i<10)
	do
		eX = GetX(gearUid) + 2 + GetRandom(GetGearRadius(gearUid)+10)
		eY = GetY(gearUid)

		tempE = AddVisualGear(eX, eY, vgtDust, 0, false)
		if tempE ~= 0 then
			g1, g2, g3, g4, g5, g6, g7, g8, g9, g10 = GetVisualGearValues(tempE)
			SetVisualGearValues(tempE, eX, eY, g3, g4, g5, g6, g7, 1, g9, 0xffff00ff )
		end
		
		i=i+1
	end
end

--[[
Remove weapon from ALL_WEAPONS array.

@param weapontype
	Weapon to remove
]]
function RemoveBuyWeapon(weapontype)
	for v,w in pairs(ALL_WEAPONS) 
	do
		if(weapontype==w[1])
		then
			table.remove(ALL_WEAPONS,v)
		end
	end
end

--[[
Sets the weapon amount to 0
]]
function CleanWeapons()
	for v,w in pairs(ALL_WEAPONS) 
	do
		AddAmmo(CurrentHedgehog,w[1],0)
	end
end

--[[
Will give the current team inf amount of weps (used for buying weapons)
]]
function InfWeapons()
	for v,w in pairs(ALL_WEAPONS) 
	do
		AddAmmo(CurrentHedgehog,w[1],100)
	end
end

--[[
Set the amount to the vector that stores the amount of weapons.

@param weapontype
	the weapontype to set the amount into
@param amount
	the amount to set
]]
function SetWeapon(weapontype,amount)

	for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
	do
		if(weapontype==w[1])
		then
			TEAM_WEAPONS[TURN_TEAM][v][2]=amount
			break
		end
	end
end

--[[
Adds to the vector that stores the amount of weapons.

@param weapontype
	the weapontype to add the amount into
@param amount
	the amount to add
]]
function AddWeapon(weapontype,amount)

	for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
	do
		if(weapontype==w[1])
		then
			if(amount==100)
			then
				TEAM_WEAPONS[TURN_TEAM][v][2]=amount
			else
				TEAM_WEAPONS[TURN_TEAM][v][2]=TEAM_WEAPONS[TURN_TEAM][v][2]+amount
			end
			
			break
		end
	end
end

--[[
Adds infinite weapon to inf mode.

@param weapontype
	the weapontype to add the amount into
@param amount
	the amount to add
]]
function IA_AddInfWeapon(weapontype,amount)

	for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
	do
		if(weapontype==w[1])
		then
			TEAM_WEAPONS[TURN_TEAM][v][3]=1+TEAM_WEAPONS[TURN_TEAM][v][3]
			
			break
		end
	end
end

--[[
Will return the amount of weapons of that type (seen from current hedgehog)

@param weapontype
	the weapontype to get the amount from

@return
	returns the weapon amount if that is stored in the vector or nil if something bad happened
]]
function GetWeaponAmount(weapontype)

	for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
	do
		if(weapontype==w[1])
		then
			return TEAM_WEAPONS[TURN_TEAM][v][2]
		end
	end
	
	return nil
end

--[[
Saves the weapons into the playing hogs vector.
]]
function SaveTeamWeapons()

	for v,w in pairs(ALL_WEAPONS) 
	do
		SetWeapon(w[1],GetAmmoCount(CurrentHedgehog, w[1]))
	end
end

--[[
Will give the "correct" weapons to the hog team, runs when going into play mode
]]
function GetTeamWeapons()
	CleanWeapons()
	
	for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
	do
		AddAmmo(CurrentHedgehog,w[1],w[2])
	end
end

--[[
Displays the current cash
]]
function DisplayCurrentCash()
	if(TEAM_CASH[TURN_TEAM]~=nil)
	then
		AddCaption(loc("You have: ")..TEAM_CASH[TURN_TEAM]..loc(" cash left!"),GetClanColor(GetHogClan(CurrentHedgehog)),capgrpMessage2)
	end
end

------------------

--[[
The storage of all ammo, and what weps that should be used.
]]
function onAmmoStoreInit()

	SetAmmo(amSkip, 9, 0, 0, 0)
	
	for v,w in pairs(ALL_WEAPONS) 
	do
		SetAmmo(w[1], w[2], w[3], w[4], w[5])
	end
end

--[[
For displaying mission information
]]
function DisplayMission(displaycash,displayit)

	local cashtags=""
	local infattack=""
	local cashrules=""
	
	if(band(GameFlags,gfInfAttack)~=0)
	then
		infattack=loc("|- Infinite attacks, Buying infinite weapons will give you 1 * amount at the start of each turn")
		cashrules=loc("Cash per team: (Recieve: 10% of [50% of starting life on hedgehogs + 10 * total clans] each turn)")
	else
		cashrules=loc("Cash per team: (Starting cash = 50% of starting life on hedgehogs + 10 * total clans)")
	end
	
	if(displaycash)
	then
		--local cashcounter=0
		cashtags="| |"..cashrules.."|"
	
		for v,w in pairs(TEAM_CASH) 
		do
			cashtags=cashtags..""..v..": "..w.."|"
			
			--cashcounter=cashcounter+1
		end
	end

	ShowMission(loc("Consumerism"),loc("Be greedy, buy your weapons!"),loc("In consumerism each player \"buy\" their own weapons ingame. Each item/weapon have a price.|You will recieve cash at the start of your turn, 5 per kill and 50% for 5 in crates. Buy your weapons with Skip and...|- 1 or 2: Buy 1 or 2 weapons|- 3: Buy infinite weapons|- 4: See prices, dont buy anything|- 5: Turn get into \"Play mode\" ON/OFF (OFF/TAB/F-Buttons to get back into the game)|TIP: You can doubletap on 1-5 to get into \"buy mode\" faster.")..infattack..cashtags, -amBirdy, 0)
	
	if(displayit==false)
	then
		HideMission()
	end
end
--[[
Runs the display of mission inf
]]
function onGameStart()
	DisplayMission(false,true)
end

--[[
Runs every turn
Set all vectors to the correct values.
Also makes sure that the hog is in PLAY MODE.
]]
function onNewTurn()
	
	CRATE_TEST=-1
	START_TEST=0
	--save team name for speed
	TURN_TEAM=GetHogTeamName(CurrentHedgehog)
	
	--run on absolute first hog
	if(TEAM_CASH[TURN_TEAM]==nil)
	then
		--remove useless weapons for purchase
		if(MapHasBorder() == true)
		then
			RemoveBuyWeapon(amAirAttack)
			RemoveBuyWeapon(amMineStrike)
			RemoveBuyWeapon(amPiano)
			RemoveBuyWeapon(amDrillStrike)
			RemoveBuyWeapon(amNapalm)
		end
		if(band(GameFlags,gfVampiric)~=0)
		then
			RemoveBuyWeapon(amVampiric)
		end
		if(band(GameFlags,gfLowGravity)~=0)
		then
			RemoveBuyWeapon(amLowGravity)
		end
		if(band(GameFlags,gfLaserSight)~=0)
		then
			RemoveBuyWeapon(amLaserSight)
		end
		if(band(GameFlags,gfInvulnerable)~=0)
		then
			RemoveBuyWeapon(amInvulnerable)
		end
	
		if(band(GameFlags,gfInfAttack)~=0)
		then
			STARTING_CASH=div(div(GetHealth(CurrentHedgehog)*50,100)+(ClansCount*10),10)
			
			for v,w in pairs(TEAMS) 
			do
				TEAM_CASH[w]=0
			end
		else
			STARTING_CASH=div(GetHealth(CurrentHedgehog)*50,100)+(ClansCount*10)
			
			for v,w in pairs(TEAMS) 
			do
				TEAM_CASH[w]=STARTING_CASH
			end
		end
	end
	
	--set weapon to skip & get into play mode.
	if(BUY_MODE[TURN_TEAM]~=PLAY_MODE)
	then
		GetIntoPlayMode(false)
		
		ParseCommand("slot 1")
	else
		--in case of
		SetInputMask(0xFFFFFFFF)
	end
	
	--add cash for inf attack mode
	if(band(GameFlags,gfInfAttack)~=0)
	then
		TEAM_CASH[TURN_TEAM]=TEAM_CASH[TURN_TEAM]+STARTING_CASH
	
		for v,w in pairs(TEAM_WEAPONS[TURN_TEAM]) 
		do
			if(w[3]>0)
			then
				AddAmmo(CurrentHedgehog,w[1],w[3]+GetAmmoCount(CurrentHedgehog,w[1]))
			end
		end
	end
	
	--generate weps for ai
	if(TEAM_CASH[TURN_TEAM]>=15 and GetHogLevel(CurrentHedgehog)~=0)
	then
		AddCaption(loc("For some strange reason, ")..TURN_TEAM..loc(" recieved some weapons..."))
		AddWeapon(amBazooka,100)
		AddWeapon(amGrenade,100)
		AddWeapon(amCluster,4)
		AddWeapon(amGasBomb,3)
		AddWeapon(amBaseballBat,2)
		AddWeapon(amShotgun,2)
		AddWeapon(amDEagle,2)
		AddWeapon(amSniperRifle,2)
		AddWeapon(amAirAttack,1)
		AddWeapon(amCake,1)
		
		--give ai weapons
		TEAM_CASH[TURN_TEAM]=0
		GetTeamWeapons()
	end
	
	DisplayMission(true,false)
end

--[[
When clicking on a weapon in the weaponmenu. 
This is only used when in buying mode.
]]
function onSetWeapon(wep)
	if(wep~=amSkip and wep~=amNothing and BUY_MODE[TURN_TEAM]~=PLAY_MODE)
	then
		if(BUY_MODE[TURN_TEAM]>=1 and BUY_MODE[TURN_TEAM]<=4)
		then
			for v,w in pairs(ALL_WEAPONS) 
			do
				if(wep==w[1])
				then
					--if its valid to buy the item (1→5)
					if(BUY_MODE[TURN_TEAM]>=1 and BUY_MODE[TURN_TEAM]<=2 and GetWeaponAmount(w[1])<100)
					then
						if(TEAM_CASH[TURN_TEAM]-w[7]*BUY_MODE[TURN_TEAM]>=0)
						then
							AddCaption(loc("Bought ")..w[6])
							AddCaption(loc("Costed: ")..TEAM_CASH[TURN_TEAM].."-"..w[7]*BUY_MODE[TURN_TEAM].."="..TEAM_CASH[TURN_TEAM]-w[7]*BUY_MODE[TURN_TEAM],GetClanColor(GetHogClan(CurrentHedgehog)),capgrpMessage2)
							
							TEAM_CASH[TURN_TEAM]=TEAM_CASH[TURN_TEAM]-w[7]*BUY_MODE[TURN_TEAM]
							
							DisplayMission(true,false)
							
							AddWeapon(w[1],BUY_MODE[TURN_TEAM])
							
							if(RETURN_MODE[TURN_TEAM]==true) 
							then
								GetIntoPlayMode(true)
								
								BUY_MODE[TURN_TEAM]=PLAY_MODE
								
								return
							end
						else
							AddCaption(loc("You can not afford that! Costs:").." ["..w[7]*BUY_MODE[TURN_TEAM].."], "..loc("You have:").." ["..TEAM_CASH[TURN_TEAM].."]")
						end
					--if its valid to buy the item (inf)
					elseif(BUY_MODE[TURN_TEAM]==3 and GetWeaponAmount(w[1])<100)
					then
						if(TEAM_CASH[TURN_TEAM]-w[8]>=0)
						then
							AddCaption(loc("Bought ")..w[6])
							AddCaption(loc("Costed: ")..TEAM_CASH[TURN_TEAM].."-"..w[8].."="..TEAM_CASH[TURN_TEAM]-w[8],GetClanColor(GetHogClan(CurrentHedgehog)),capgrpMessage2)
							
							TEAM_CASH[TURN_TEAM]=TEAM_CASH[TURN_TEAM]-w[8]
							
							DisplayMission(true,false)
							
							if(band(GameFlags,gfInfAttack)==0 or w[1]==amRope or w[1]==amJetpack or w[1]==amSwitch or w[1]==amVampiric or w[1]==amLaserSight or w[1]==amExtraDamage or w[1]==amInvulnerable )
							then
								AddWeapon(w[1],100)
							else
								IA_AddInfWeapon(w[1],1)
								AddWeapon(w[1],1)
							end
							
							if(RETURN_MODE[TURN_TEAM]==true) 
							then
								GetIntoPlayMode(true)
								
								BUY_MODE[TURN_TEAM]=PLAY_MODE
								
								return
							end
						else
							AddCaption(loc("You can not afford that! Costs:").." ["..w[8].."], "..loc("You have:").." ["..TEAM_CASH[TURN_TEAM].."]")
						end
					--used to see the amount
					elseif(BUY_MODE[TURN_TEAM]==4)
					then
						AddCaption(w[6]..loc(" costs: 1").." = ["..w[7].."], infinite = ["..w[8].."]")
						DisplayCurrentCash()
					end
					
					
				end
			end
		end
		ParseCommand("setweap " .. string.char(amSkip))
	end
end

--[[
Will set the current hog into play mode
]]
function GetIntoPlayMode(displaytext)
	if(displaytext)
	then
		AddCaption(loc("Play mode"))
		--PlaySound(sndReinforce,CurrentHedgehog)
	end
	
	SetInputMask(0xFFFFFFFF)
	BUY_MODE[TURN_TEAM]=PLAY_MODE
	--give the user back its weapons
	GetTeamWeapons()
end
--[[
Will run every time the users press the 1-5-buttons
---
focuses on the skip weapon & selecting between modes.
]]
function onTimer(slot)
	if((GetCurAmmoType()==amSkip or (DOUBLE_TAP>=2 and DOUBLE_TAP_BUTTON==slot)) and BUY_MODE[TURN_TEAM]~=nil)
	then
		if(slot==5 and RETURN_MODE[TURN_TEAM]==false)
		then
			RETURN_MODE[TURN_TEAM]=true
			AddCaption(loc("Set: RETURN AFTER PURCHASE MODE ")..loc("[ON]"),0xffffffff,capgrpMessage2)
			
			GetIntoPlayMode(true)
			
			BUY_MODE[TURN_TEAM]=PLAY_MODE
			
			ParseCommand("slot 1")
			
			return
		end
		--set the weapon to skip so the user wont be able to use the weapons from the store
		ParseCommand("setweap " .. string.char(amSkip))

		--use once
		if(BUY_MODE[TURN_TEAM]==PLAY_MODE)
		then
			SaveTeamWeapons()
			
			--give the user inf weapons
			InfWeapons()
			
			SetInputMask(band(0xFFFFFFFF, bnot(gmAttack)))
		end
		
		if(slot==1)
		then
			AddCaption(loc("Entered: Buy [1] weapon mode"))
		elseif(slot>=2 and slot <= 2)
		then
			AddCaption(loc("Entered: Buy").." [".. slot .."] "..loc("weapons mode"))
		elseif(slot==3)
		then
			AddCaption(loc("Entered: Buy [infinite] weapons mode"))
		elseif(slot==4)
		then
			AddCaption(loc("Entered: See price mode"))
		elseif(slot==5)
		then
			RETURN_MODE[TURN_TEAM]=false
			AddCaption(loc("Set: RETURN AFTER PURCHASE MODE ")..loc("[OFF]"))
		end

		DisplayCurrentCash()
		
		BUY_MODE[TURN_TEAM]=slot
	end
	
	if(DOUBLE_TAP==0)
	then
		DOUBLE_TAP=1
		DOUBLE_TAP_BUTTON=slot
	end
end

--[[
When pressing the F-buttons
sets into play mode
]]
function onSlot(slot)
	if(BUY_MODE[TURN_TEAM]~=PLAY_MODE)
	then
		GetIntoPlayMode(true)
			
		BUY_MODE[TURN_TEAM]=PLAY_MODE
		
		--48=ascii=0
		ParseCommand("slot " .. string.char(slot+49))
	end
end

--[[
when pressing TAB
sets into play mode
]]
function onSwitch()
	if(GetCurAmmoType()==amSkip)
	then
		if(BUY_MODE[TURN_TEAM]~=PLAY_MODE)
		then
			GetIntoPlayMode(true)
			
			BUY_MODE[TURN_TEAM]=PLAY_MODE
			
			ParseCommand("slot 1")
		end
	end
end

--[[
Runs every 20 tick
mostly used for double tap function
]]
function onGameTick20()
	if(DOUBLE_TAP>0)
	then
		DOUBLE_TAP=DOUBLE_TAP+1
		
		if(DOUBLE_TAP>=20)
		then
			DOUBLE_TAP=0
			DOUBLE_TAP_BUTTON=0
		end
	end
	
	if(START_TEST<10 and BUY_MODE[TURN_TEAM]==PLAY_MODE)
	then
		if(GetAmmoCount(CurrentHedgehog,amVampiric)==100)
		then
			if(START_TEST==0)
			then
				ParseCommand("setweap " .. string.char(amVampiric))
			elseif(START_TEST==1)
			then
				SetGearMessage(CurrentHedgehog,gmAttack)
			end
		end
		
		if(GetAmmoCount(CurrentHedgehog,amInvulnerable)==100)
		then
			if(START_TEST==2)
			then
				ParseCommand("setweap " .. string.char(amInvulnerable))
			elseif(START_TEST==3)
			then
				SetGearMessage(CurrentHedgehog,gmAttack)
			end
		end
		
		if(GetAmmoCount(CurrentHedgehog,amLaserSight)==100)
		then
			if(START_TEST==4)
			then
				ParseCommand("setweap " .. string.char(amLaserSight))
			elseif(START_TEST==5)
			then
				SetGearMessage(CurrentHedgehog,gmAttack)
			end
		end
		
		if(GetAmmoCount(CurrentHedgehog,amExtraDamage)==100)
		then
			if(START_TEST==6)
			then
				ParseCommand("setweap " .. string.char(amExtraDamage))
			elseif(START_TEST==7)
			then
				SetGearMessage(CurrentHedgehog,gmAttack)
			end
		end
		
		if(GetAmmoCount(CurrentHedgehog,amSwitch)==100)
		then
			if(START_TEST==8)
			then
				ParseCommand("setweap " .. string.char(amSwitch))
			elseif(START_TEST==9)
			then
				SetGearMessage(CurrentHedgehog,gmAttack)
			end
		end
		
		START_TEST=START_TEST+1
	end
end

--[[
Run when a gear is deleted
used for giving cash from crates and hogs
]]
function onGearDelete(gearUid)
	
	if(GetGearType(gearUid) == gtHedgehog and gearUid~=CurrentHedgehog)
	then
		AddCaption(TURN_TEAM..loc(" recieved 5 cash from the kill!"),GetClanColor(GetHogClan(CurrentHedgehog)),capgrpMessage2)
		TEAM_CASH[TURN_TEAM]=TEAM_CASH[TURN_TEAM]+5
		DisplayMission(true,false)
	elseif(GetGearType(gearUid) == gtCase and gearUid~=CRATE_TEST and GetHealth(gearUid)==0 and GetRandom(2)==0 and gearIsInCircle(CurrentHedgehog,GetX(gearUid), GetY(gearUid), 50, false)==true)
	then
		AddCaption(TURN_TEAM..loc(" recieved 5 cash from the crate!"),GetClanColor(GetHogClan(CurrentHedgehog)),capgrpMessage2)
		TEAM_CASH[TURN_TEAM]=TEAM_CASH[TURN_TEAM]+5
		
		--show some sparkles
		CashAnimation(gearUid)
		
		DisplayMission(true,false)
	end
end

--[[
Run when a gear is added
init all teams here
]]
function onGearAdd(gearUid)
	
	if(GetGearType(gearUid) == gtHedgehog and TEAM_CASH[GetHogTeamName(gearUid)]==nil)
	then
		BUY_MODE[GetHogTeamName(gearUid)]=PLAY_MODE
		TEAM_WEAPONS[GetHogTeamName(gearUid)]={}
		RETURN_MODE[GetHogTeamName(gearUid)]=true
		--add team to vector
		table.insert(TEAMS,GetHogTeamName(gearUid))
		--set all weapons to 0
		for v,w in pairs(ALL_WEAPONS) 
		do
			table.insert(TEAM_WEAPONS[GetHogTeamName(gearUid)],v,{w[1],0,0})
		end
	end
end

--[[
To check if a hog picked the crate
]]
function onGearDamage(gearUid, damage)
	if (GetGearType(gearUid) == gtCase)
	then
		CRATE_TEST=gearUid
	end
end